//=============================================================================
//		opnaw : OPNA unit with wait
//			ver 0.03
//=============================================================================

#ifndef OPNAW_H
#define OPNAW_H

#include	"opna.h"
#include	"s98/S98File.h"


// ꎟԗL̍g
#define	SOUND_55K			  55466

// wait ŌvZ buffer size(samples)
#define		WAIT_PCM_BUFFER_SIZE  65536

// `ԎɌvZ buffer size(samples)
#define		IP_PCM_BUFFER_SIZE  2048

namespace FM {

	class OPNAW : public OPNA
	{
	public:
		OPNAW();
		~OPNAW();

		bool	Init(uint c, uint r, bool ipflag, const char* path, S98File*);
		bool	SetRate(uint c, uint r, bool ipflag = false);

		void	SetFMWait(int nsec);				// FM wait(nsec)
		void	SetSSGWait(int nsec);				// SSG wait(nsec)
		void	SetRhythmWait(int nsec);			// Rhythm wait(nsec)
		void	SetADPCMWait(int nsec);				// ADPCM wait(nsec)

		int		GetFMWait(void);					// FM wait(nsec)
		int		GetSSGWait(void);					// SSG wait(nsec)
		int		GetRhythmWait(void);				// Rhythm wait(nsec)
		int		GetADPCMWait(void);					// ADPCM wait(nsec)

		void	SetReg(uint addr, uint data);		// WX^ݒ
		void	Mix(Sample* buffer, int nsamples);	// 
		void	ClearBuffer(void);					// obt@NA
	
	private:
		S98File *m_S98;
		Sample	pre_buffer[WAIT_PCM_BUFFER_SIZE * 2];
													// wait ̍̑ޔ
		int		fmwait;								// FM Wait(nsec)
		int		ssgwait;							// SSG Wait(nsec)
		int		rhythmwait;							// Rhythm Wait(nsec)
		int		adpcmwait;							// ADPCM Wait(nsec)
	
		int		fmwaitcount;						// FM Wait(count*1000)
		int		ssgwaitcount;						// SSG Wait(count*1000)
		int		rhythmwaitcount;					// Rhythm Wait(count*1000)
		int		adpcmwaitcount;						// ADPCM Wait(count*1000)
	
		int		read_pos;							// ݈ʒu
		int		write_pos;							// ǂݏoʒu
		int		count2;								// count (*1000)	

		Sample	ip_buffer[IP_PCM_BUFFER_SIZE * 2];
													// `Ԏ̃[N
		uint	rate2;								// o͎g
		bool	interpolation2;						// ꎟԃtO
		int		delta;								// (16384Tvŕ)
	
		void	CalcWaitPCM(int waitcount);			// SetReg() wait  PCM vZ
		void	_Mix(Sample* buffer, int nsamples);	// iꎟԂȂVer.)

	};
}

#endif	// OPNAW_H
