//=============================================================================
//		86B PCM Driver uP86DRVv Unit
//			programmed by M.Kajihara 96/01/16
//			Windows Converted by C60
//=============================================================================

#ifndef P86DRV_H
#define P86DRV_H

#include <windows.h>
//#include "types.h"

//	DLL  ߂l
#define	_P86DRV_OK					  0		// I
#define	_ERR_OPEN_P86_FILE			  1		// P86 JȂ
#define	_ERR_WRONG_P86_FILE		 	  2		// P86 ̌`قȂĂ
#define	_WARNING_P86_ALREADY_LOAD	  3		// P86 ͂łɓǂݍ܂Ă
#define	_ERR_OUT_OF_MEMORY			 99		// mۂłȂ

#define	SOUND_44K				  44100
#define	SOUND_22K				  22050
#define	SOUND_11K				  11025

#define	P86DRV_VER				 "1.1c"
#define	MAX_P86						256
#define vers					   0x11
#define date			"Sep.11th 1996"


typedef int				Sample;
typedef	unsigned char	uchar;
typedef	unsigned int	uint;


#pragma pack( push, enter_include1 )
#pragma pack(1)

typedef struct p86headertag		// header(original)
{
	char	header[12];			// "PCM86 DATA",0,0
	uchar	Version;
	char	All_Size[3];
	struct {
		uchar	start[3];
		uchar	size[3];
	} pcmnum[MAX_P86];
} P86HEADER;

#pragma pack( pop, enter_include1 )

typedef struct p86headertag2	// header(for PMDWin, int alignment)
{
	char	header[12];			// "PCM86 DATA",0,0
	int		Version;
	int		All_Size;
	struct {
		int		start;
		int		size;
	} pcmnum[MAX_P86];
} P86HEADER2;


const int ratetable[] = {
	4135, 5513, 8270, 11025, 16540, 22050, 33080, 44100
};


class P86DRV
{
public:
	P86DRV();
	~P86DRV();
	
	bool Init(uint r, bool ip);						// 
	bool Stop(void);								// P86 ~
	bool Play(void);								// P86 Đ
	bool Keyoff(void);								// P86 keyoff
	int Load(char *filename);						// P86 ǂݍ
	bool SetRate(uint r, bool ip);					// [gݒ
	void SetVolume(int volume);						// S̉ʒߗp
	bool SetVol(int _vol);							// ʐݒ
	bool SetOntei(int rate, uint ontei);			// g̐ݒ
	bool SetPan(int flag, int data);				// PAN ݒ
	bool SetNeiro(int num);							// PCM ԍݒ
	bool SetLoop(int loop_start, int loop_end, int release_start, bool adpcm);
													// [vݒ
	void Mix(Sample* dest, int nsamples);			// 
	char	p86_file[_MAX_PATH];					// t@C
	P86HEADER2 p86header;							// P86 ̉Fwb_[

private:
	bool	interpolation;							// ⊮邩H
	int		rate;									// Đg
	int		srcrate;								// f[^̎g
	uint	ontei;									// (fnum)
	int		vol;									// 
	uchar	*p86_addr;								// P86 ۑp|C^
	uchar	*start_ofs;								// PCMf[^Ԓn
	int		start_ofs_x;							// PCMf[^Ԓnij
	int		size;									// cTCY
	uchar	*_start_ofs;							// JnPCMf[^Ԓn
	int		_size;									// PCMf[^TCY
	int		addsize1;								// PCMAhXZl ()
	int		addsize2;								// PCMAhXZl ()
	uchar	*repeat_ofs;							// s[gJnʒu
	int		repeat_size;							// s[g̃TCY
	uchar	*release_ofs;							// [XJnʒu
	int		release_size;							// [X̃TCY
	bool	repeat_flag;							// s[g邩ǂflag
	bool	release_flag1;							// [X邩ǂflag
	bool	release_flag2;							// [Xǂflag

	int		pcm86_pan_flag;		// pf[^P(bit0=/bit1=E/bit2=t)
	int		pcm86_pan_dat;		// pf[^Q(ʂTCh̉ʒl)
	bool	play86_flag;							// ?flag

	int		AVolume;
//	static	Sample VolumeTable[16][256];			// ʃe[u
	Sample VolumeTable[16][256];					// ʃe[u

	void	MakeVolumeTable(int volume);
	void	double_trans(Sample* dest, int nsamples);
	void	double_trans_g(Sample* dest, int nsamples);
	void	left_trans(Sample* dest, int nsamples);
	void	left_trans_g(Sample* dest, int nsamples);
	void	right_trans(Sample* dest, int nsamples);
	void	right_trans_g(Sample* dest, int nsamples);
	void	double_trans_i(Sample* dest, int nsamples);
	void	double_trans_g_i(Sample* dest, int nsamples);
	void	left_trans_i(Sample* dest, int nsamples);
	void	left_trans_g_i(Sample* dest, int nsamples);
	void	right_trans_i(Sample* dest, int nsamples);
	void	right_trans_g_i(Sample* dest, int nsamples);
	bool	add_address(void);
};

#endif	// P86DRV_H
