//=============================================================================
//		8 Channel PCM Driver uPPZ8v Unit(Light Version)
//			Programmed by UKKY
//			Windows Converted by C60
//=============================================================================

#ifndef PPZ8L_H
#define PPZ8L_H

#include	<windows.h>
//#include	"types.h"


#define	SOUND_44K		 44100

#define		_PPZ8_VER		"1.07"
#define		RATE_DEF	 SOUND_44K
#define		VNUM_DEF			12
#define		PCM_CNL_MAX 		 8
#define		X_N0			  0x80
#define		DELTA_N0		   127

//	DLL  ߂l
#define	_PPZ8_OK				 	  0		// I
#define	_ERR_OPEN_PPZ_FILE			  1		// PVI/PZI JȂ
#define	_ERR_WRONG_PPZ_FILE		 	  2		// PVI/PZI ̌`قȂĂ
#define	_WARNING_PPZ_ALREADY_LOAD	  3		// PVI/PZI ͂łɓǂݍ܂Ă

#define	_ERR_OUT_OF_MEMORY			 99		// mۂłȂ

typedef int				Sample;
typedef	unsigned char	uchar;
typedef	unsigned int	uint;

typedef struct channelworktag
{
	int		PCM_ADD_L;				// AhX LOW
	int		PCM_ADD_H;				// AhX HIGH
	int		PCM_ADDS_L;				// AhX LOWi̒lj
	int		PCM_ADDS_H;				// AhX HIGHi̒lj
	int		PCM_SORC_F;				// f[^̍Đ[g
	int		PCM_FLG;				// ĐtO
	int		PCM_VOL;				// {[
	int		PCM_PAN;				// PAN
	int		PCM_NUM;				// PCMԍ
	int		PCM_LOOP_FLG;			// [vgptO
	uchar	*PCM_NOW;				// ݂̒l
	int		PCM_NOW_XOR;			// ݂̒lij
	uchar	*PCM_END;				// ݂̏IAhX
	uchar	*PCM_END_S;				// {̏IAhX
	uchar	*PCM_LOOP;				// [vJnAhX
	uint	PCM_LOOP_START;			// jAȃ[vJnAhX
	uint	PCM_LOOP_END;			// jAȃ[vIAhX
	bool	pviflag;				// PVI Ȃ true
} CHANNELWORK;

#pragma pack( push, enter_include1 )
#pragma pack(1)

typedef struct pziheadertag
{
	char	header[4];				// 'PZI1'
	char	dummy1[0x0b-4];			// \P
	uchar	pzinum;					// PZIf[^̒`
	char	dummy2[0x20-0x0b-1];	// \Q
	struct	{
		DWORD	startaddress;		// 擪AhX
		DWORD	size;				// f[^
		DWORD	loop_start;			// [vJn|C^
		DWORD	loop_end;			// [vI|C^
		WORD	rate;				// Đg
	} pcmnum[128];
} PZIHEADER;

typedef struct pviheadertag
{
	char	header[4];				// 'PVI2'
	char	dummy1[0x0b-4];			// \P
	uchar	pvinum;					// PVIf[^̒`
	char	dummy2[0x10-0x0b-1];	// \Q
	struct	{
		WORD	startaddress;		// 擪AhX
		WORD	endaddress;			// f[^
	} pcmnum[128];
} PVIHEADER;

#pragma pack( pop, enter_include1 )


class PPZ8
{
public:
	PPZ8();
	~PPZ8();
	
	bool Init(uint rate, bool ip);				// 00H 
	bool Play(int ch, int bufnum, int num, WORD start, WORD stop);
												// 01H PCM 
	bool Stop(int ch);							// 02H PCM ~
	int Load(char *filename, int bufnum);		// 03H PVI/PZI̧ق̓ǂݍ
	bool SetVol(int ch, int vol);				// 07H حѐݒ
	bool SetOntei(int ch, uint ontei);			// 0BH g̐ݒ
	bool SetLoop(int ch, uint loop_start, uint loop_end);
												// 0EH ٰ߲̐ݒ
	void AllStop(void);							// 12H (PPZ8)S~
	bool SetPan(int ch, int pan);				// 13H (PPZ8)PANw
	bool SetRate(uint rate, bool ip);			// 14H (PPZ8)ڰĐݒ
	bool SetSourceRate(int ch, int rate);		// 15H (PPZ8)ްgݒ
	void SetAllVolume(int vol);					// 16H (PPZ8)Sհт̐ݒi86B Mixer)
	void SetVolume(int vol);
	//PCMTMP_SET		;17H PCMؐݒ
	void ADPCM_EM_SET(bool flag);				// 18H (PPZ8)ADPCMG~[g
	//REMOVE_FSET		;19H (PPZ8)풓׸ސݒ
	//FIFOBUFF_SET		;1AH (PPZ8)FIFOޯ̧̕ύX
	//RATE_SET		;1BH (PPZ8)WSSڍڰĐݒ

	void Mix(Sample* dest, int nsamples);

	PZIHEADER PCME_WORK[2];						// PCM̉Fwb_[
	bool	pviflag[2];							// PVI Ȃ true
	char	PVI_FILE[2][_MAX_PATH];				// t@C

private:
	void	WORK_INIT(void);					// ܰ
	bool	ADPCM_EM_FLG;						// CH8 ADPCM G~[g邩H
	bool	interpolation;						// ⊮邩H
	int		AVolume;
	CHANNELWORK	channelwork[PCM_CNL_MAX];		// e`l̃[N
	uchar	*XMS_FRAME_ADR[2];					// XMSŊmۂAhXijAj
	int		XMS_FRAME_SIZE[2];					// PZI or PVI f[^TCY
	int		PCM_VOLUME;							// 86B MixerS̃{[
												// (DEF=12)
	int		volume;								// S̃{[
												// (opna unit ݊)
	int		DIST_F;								// Đg
	
//	static Sample VolumeTable[16][256];			// ʃe[u
	Sample VolumeTable[16][256];				// ʃe[u
	void	MakeVolumeTable(int vol);			// ʃe[u̍쐬
};

#endif	// PPZ8L_H
