/**
 * PMDWinłgĂ炭炭S98
 *
 * @year 2011
 * @author rururu
 *
 */

#pragma warning(disable : 4996)
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "PMDWinImport.h"

struct stWork {
	HINSTANCE PmdDll;		/**< PDMWin.dll handle */
	IPMDWIN *PmdWin;		/**< PMDWin instance */
	char mesbuf[5][1024+1];
};

static stWork g_work;

/**
 * Load DLL
 *
 */
static bool LoadDll()
{
	// DLL̃[h
	if ( g_work.PmdDll == 0) {
		g_work.PmdDll = ::LoadLibrary( "PMD2S98.dll" );
		if ( g_work.PmdDll ) {
			return true;
		}
	}
	return false;
}

static bool PMDInit()
{
	if ( LoadDll() == false ) {
		return false;
	}

	// ֐AhX̎擾
	HRESULT (WINAPI*pmd_CoCreateInstance)(
		REFCLSID, LPUNKNOWN, DWORD, REFIID, LPVOID*);
	pmd_CoCreateInstance = (HRESULT (WINAPI*)(REFCLSID, LPUNKNOWN, DWORD, REFIID, LPVOID*))GetProcAddress(g_work.PmdDll, "pmd_CoCreateInstance");

	// PMDWin
	if (pmd_CoCreateInstance &&
		SUCCEEDED(pmd_CoCreateInstance(CLSID_PMDWIN, NULL, CLSCTX_ALL, IID_IPMDWIN, (void**)&g_work.PmdWin))) {
		g_work.PmdWin->init("");	// @todo rhythm path
	}
	return true;
}

static void PMDDeinit()
{
	if (g_work.PmdWin) {
		g_work.PmdWin->Release();
	}
	::FreeLibrary( g_work.PmdDll );
}

static bool PMDPlay( char *_fname )
{
	int error = g_work.PmdWin->music_load( _fname );
	switch(error) {
	  case ERR_OPEN_MUSIC_FILE:
		return false;
	  case ERR_WRONG_MUSIC_FILE:
	  case ERR_WRONG_PPZ1_FILE:
	  case ERR_WRONG_PPZ2_FILE:
	  case ERR_WRONG_PPC_FILE:
	  case ERR_OUT_OF_MEMORY:
	  case ERR_OTHER:
	  case PMDWIN_OK:
	  default:
		break;
	}
	g_work.PmdWin->setpcmrate(SOUND_55K);
	g_work.PmdWin->music_start();
	return true;
}

static const char* infostr[] = {
	"Title    :",
	"Composer :",
	"Arranger :",
	"Comment  :",
	"Comment  :",
};

/**
 * t@C̕\
 *
 * @param _fname [in] file name
 *
 */
static bool PMDFileInfo( char *_fname )
{
	bool result = true;

	printf( "============================================================================\n");

	for (int i=1; i<=5; i++) {
		if ( g_work.PmdWin->fgetmemo3( g_work.mesbuf[i-1], _fname, i ) != PMDWIN_OK ) {
			result = false;
			break;
		}
		printf( "%s %s\n", infostr[i-1], g_work.mesbuf[i-1] );
	}

	printf( "============================================================================\n");

	return result;
}

/**
 * PMDWinŃ^Oł̂͌Ȃ̂
 * Ń^Oo^B
 */
void S98Tag(char *_path)
{
	char outname[_MAX_PATH];
	{
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_FNAME];
		char ext[_MAX_EXT];
		_splitpath( _path, drive, dir, fname, ext );
		strcpy( outname, fname );
		strcat( outname, ".s98" );
	}
	FILE *fp = fopen(outname, "r+b");
	if (fp) {
		fseek(fp, 0, SEEK_END);
		DWORD src_size = (DWORD)ftell(fp);
		fprintf(fp, "[S98]title=%s\nartist=%s\ncomment=%s\ns98by=pmd2s98\n",
				g_work.mesbuf[0],
				(g_work.mesbuf[2][0] == 0) ? g_work.mesbuf[1] : g_work.mesbuf[2],
				g_work.mesbuf[3]);
		fseek(fp, 0x10, SEEK_SET);
		for (int i=0; i<4; i++) {
			BYTE num = src_size & 0xff;
			fwrite(&num, 1, 1, fp);
			src_size >>= 8;
		}
		fclose(fp);
	}
}

static void copyright()
{
	printf( "PMD2S98 ver1.00 Copyright (C) KAJA/C60/RuRuRu\n" );
}

static void usage()
{
	printf( "\nusage  : pmd2s98 [filename] [opt]\n" );
	printf( "option : -l??  loop [1~]\n" );
	printf( "       : -f??  fade out [0~127]\n" );
	printf( "       : -n[-] ssg with rhythm\n" );
}

int main( int argc,char *argv[] )
{
	copyright();

	if ( argc < 2 ) {
		usage();
		return -1;
	}

	if ( PMDInit() == false ) {
		printf( "No DLL.\n" );
		return -2;
	}

	if ( PMDFileInfo( argv[1] ) == false ) {
		PMDDeinit();
		printf( "No file.\n" );
		return -3;
	}

	// Parse command line arguments.
	int LoopLimit = 2;
	int Fadeout = 16;
	bool SsgRhythm = true;

	if ( argc > 2 ) {
		for ( int i=2; i < argc ; i++) {
			if (argv[i][0] != '-') {
				continue;
			} else {
				switch(argv[i][1]) {
				  case 'l':
				  case 'L':
					LoopLimit = atoi(&argv[i][2]);
					if (LoopLimit < 0) {
						LoopLimit = 0;
					}
					break;
				  case 'f':
				  case 'F':
					Fadeout = atoi(&argv[i][2]);
					if (Fadeout > 127) {
						Fadeout = 127;
					}
					if (Fadeout < 0) {
						Fadeout = 0;
					}
					break;
				  case 'n':
				  case 'N':
					if (argv[i][2] == '-') {
						SsgRhythm = true;
					} else {
						SsgRhythm = false;
					}
					break;
				  default:
					printf("Unknown opt. %s\n", argv[i]);
					break;
				}
			}
		}
	}

	printf("\n%d loop / fade speed %d.\n", LoopLimit, Fadeout);

	g_work.PmdWin->setrhythmwithssgeffect( SsgRhythm ? TRUE : FALSE );

	if ( PMDPlay( argv[1] ) == false ) {
		PMDDeinit();
		printf( "Play error.\n" );
		return -4;
	}


	int LoopCount = 0;
	short pcmbuf[4];	// dummy

	while ( LoopCount < LoopLimit && LoopCount != -1 ) {
		LoopCount = g_work.PmdWin->getloopcount();
		g_work.PmdWin->getpcmdata(pcmbuf, 1);
	}

	if (Fadeout) {
		g_work.PmdWin->fadeout(Fadeout);
		while ( LoopCount != -1 ) {
			LoopCount = g_work.PmdWin->getloopcount();
			g_work.PmdWin->getpcmdata(pcmbuf, 1);
		}
	}

	PMDDeinit();

	S98Tag(argv[1]);
}

